#include <stdio.h>
#include <stdlib.h>
#include "sincos.h"



void print_usage(){
/*Display help message*/
printf("USEAGE: sincos x \n---------------------------------------------------------\nThis is sincos  an application that prints a table of \nangle \t sin \t cos \nvalues for angles between 0 and 360 degrees. \nThe application receives exactly one argument x which is \nthe (natural) number of steps to use for printing. \nOne more line is shown, if 360 equals 0 modulo x.\nx is restricted to values less or equal than 360 \n---------------------------------------------------------\n");
}


int valid_stepcount(const char *userarg){
/*If the users argument was a valid one, this function will return a non 0 value between 1 and 360 */
	char *endptr;
	unsigned long test;
	test= strtoul(userarg, &endptr,10); 
	if ( test == 0   	
	|| *endptr != 0
	|| test > 360 )    {
		return 0;
	}
	/*else:*/
	return (int) test;
}


int main(int argc , char *argv[]){
/*Main prog, test argument, call sincos */
	int stepcount;
	if (argc != 2   /* only 1 argument is valid ...*/
	|| (stepcount=valid_stepcount(argv[1]))==0 ) /*...it must be a number..*/
         {
		print_usage();
		return 0;
	}
	
         /*uncomment next 2 lines for more information
	printf("stepcount ist %d \n",stepcount );
	printf("We'll have a stepwidth of %d \n", 360 / stepcount );
         */
	mysincos(360 / stepcount);
	mysincos(260 / stepcount);
	mysincos(160 / stepcount);
	mysincos(264 / stepcount);
	mysincos(340 / stepcount);
	mysincos(260 / stepcount);
	if(argc == 9)
		mysincos(160 / stepcount);
	
	return 0;
	
}

