#!/usr/bin/env ruby

require "pp"
begin
require "yaml"
$c = YAML::load_file("../admin/config.yaml")

require "cgi"
$cgi = CGI.new
$header = {}
$header["type"] = "text/html"
#$header["type"] = "application/xhtml+xml"
$header["charset"] = "utf-8"
$html = <<HTML
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN"
  "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
<head>
	<meta http-equiv="Content-Type" content="#{$header["type"]}; charset=#{$header["charset"]}" />
	<title>Pissing Contest</title>
	<link rel="shortcut icon" href="/favicon.ico" type="image/vnd.microsoft.icon">
	<link rel='stylesheet' type='text/css' href='/style.css'/>
</head>
<body>
HTML
require "pg"
$pgsql = PGconn.open(:dbname => $c["db_name"], :user => $c["db_user"], :password => $c["db_password"], :host => "localhost")

user = $cgi.remote_user
questions = $pgsql.exec("select questionid,description from questions where ask_num is not null order by ask_num").entries
if questions.empty?
	$html << "There is no question!"
else


	MAXRATING = 2

	qIds = questions.collect{|q| q["questionid"]}
	if $cgi.include?("question") && qIds.include?($cgi["question"])
		curQuestion = qIds.index($cgi["question"])
	else
		curQuestion = questions.size - 1
	end
	curQuestionId = questions[curQuestion]["questionid"]

	userrating = $pgsql.exec(%Q/select rating from ratings where "user" = '#{user}' and "question" = #{curQuestionId}/).entries[0]
	if userrating
		ratingvalue = userrating["rating"].to_i
	else
		ratingvalue = 0
	end

	if $cgi.include?("rating")
		ratingvalue = $cgi["rating"].to_i
		ratingvalue = MAXRATING if ratingvalue > MAXRATING
		ratingvalue = -MAXRATING if ratingvalue < -MAXRATING

		if $pgsql.exec(%Q/select * from ratings where "user" = '#{user}' and "question" = #{curQuestionId}/).entries.empty?
			$pgsql.exec(%Q/insert into ratings ("user", "rating", "question") values('#{user}', #{ratingvalue}, #{curQuestionId})/)
		else
			$pgsql.exec(%Q/update ratings set rating = #{ratingvalue} where "user" = '#{user}' and "question" = #{curQuestionId}/)
		end
		$header["status"] = "REDIRECT"
		$header["Cache-Control"] = "no-cache"
		$header["Location"] = "."
		$html << %Q|The changes were saved, you should be <a href=".">redirected</a>.|

	else

		$html << <<HEAD
<div id='ct0'></div>
<div id='ct1'>
<div id='content'>
<div id='bodyText'>
<div>
<h1>Hi #{user}!</h1>
Question: #{$pgsql.exec(%Q/select description from questions where "questionid" = #{curQuestionId}/).entries[0]["description"]}
<form method='POST'>
<input type='hidden' name='question' value='#{curQuestionId}' />
Emacs
HEAD

		(-MAXRATING..MAXRATING).each{|i|
			$html << "<td><input type='radio' name='rating' value='#{i}'"
			$html << "checked='checked'" if i == ratingvalue
			$html << "></td>"
		}
		$html << <<HTML
Vim
<br />
<input type='submit' />
</form>
HTML
		$html << "<a href='?question=#{questions[curQuestion-1]["questionid"]}'>previous</a> " if curQuestion > 0
		$html << "<a href='?question=#{questions[curQuestion+1]["questionid"]}'>next</a>" if curQuestion < questions.size - 1
		$html << <<HTML
</div>
</div>
</div>
</div>
<div id='ct2'></div>
HTML

	end
end

$html << "</body>"
$cgi.out($header){$html}
rescue => e
	puts
	puts "There was an exception, sorry.\n"
	pp e.backtrace
	pp e
end
